---
title: Alt-Svc
slug: Web/HTTP/Headers/Alt-Svc
tags:
  - HTTP
  - HTTP Header
  - NeedsCompatTable
  - Reference
---
<div>{{HTTPSidebar}}</div>

<p>The <strong><code style="white-space: nowrap;">Alt-Svc</code></strong> HTTP response header is used to advertise alternative services through which the same resource can be reached. An alternative service is defined by a protocol/host/port combination.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">Alt-Svc: clear
Alt-Svc: <var>&lt;protocol-id&gt;</var>=<em>&lt;alt-authority&gt;</em>; ma=<var>&lt;max-age&gt;</var>
Alt-Svc: <var>&lt;protocol-id&gt;</var>=<em>&lt;alt-authority&gt;</em>; ma=<var>&lt;max-age&gt;</var>; persist=1</pre>

<dl>
 <dt><code>clear</code></dt>
 <dd>The special value ''clear" indicates that the origin requests all alternatives for that origin to be invalidated.</dd>
 <dt><code>&lt;protocol-id&gt;</code></dt>
 <dd>The {{Glossary("ALPN")}} protocol identifier. Examples include h2 for HTTP/2 and h3-25 for draft 25 of the HTTP/3 protocol.</dd>
 <dt><code>&lt;alt-authority&gt;</code></dt>
 <dd>The quoted string specifying the alternative authority which consists of an optional host override, a colon, and a mandatory port number.</dd>
 <dt><code>ma=&lt;max-age&gt;</code>{{Optional_Inline}}</dt>
 <dd>The number of seconds for which the alternative service is considered fresh. If omitted, it defaults to 24 hours. Alternative service entries can be cached for up to <em>&lt;max-age&gt;</em> seconds, minus the age of the response (from the {{ httpheader("Age") }} header). If the cached entry expires, the client can no longer use this alternative service for new connections.</dd>
 <dt><code>persist=1</code>{{Optional_Inline}}</dt>
 <dd>Usually cached alternative service entries are cleared on network configuration changes. Use of the persist=1 parameter ensures that the entry is not deleted through such changes.</dd>
</dl>

<p>Multiple entries can be specified in a single <code>Alt-Svc</code> header using comma as separator. In that case, early entries are considered more preferable.</p>

<h2 id="Example">Example</h2>

<pre>Alt-Svc: h2=":443"; ma=2592000;
Alt-Svc: h2=":443"; ma=2592000; persist=1
Alt-Svc: h2="alt.example.com:443", h2=":443"
Alt-Svc: h3-25=":443"; ma=3600, h2=":443"; ma=3600</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{RFC(7838)}}</td>
   <td><span class="spec-RFC">IETF RFC</span></td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a class="external external-icon" href="https://github.com/mdn/browser-compat-data" rel="noopener">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</div>

<p>{{Compat("http.headers.Alt-Svc")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/HTTP/Basics_of_HTTP/Identifying_resources_on_the_Web">Identifying resources on the Web</a></li>
</ul>
